/*
**
**    Created by PROGRESS ProxyGen (Progress Version 10.2A) Tue Dec 15 10:26:46 PST 2009
**
*/

package com.rtbtsms.scm.eclipse.proxy;

import com.progress.open4gl.*;
import com.progress.common.ehnlog.IAppLogger;
import com.progress.common.ehnlog.LogUtils;
import com.progress.open4gl.dynamicapi.IPoolProps;
import com.progress.open4gl.javaproxy.Connection;
import com.progress.message.jcMsg;
import java.math.BigDecimal;
import java.util.Date;
import java.sql.ResultSet;
import java.io.IOException;

//
// Roundtable
//
/**
*    
*
*    @author    Tugboat Software
*    @version 
*/
public class Roundtable implements SDOFactory
{
    // "This proxy version is not compatible with the current
    // version of the dynamic API."
    protected static final long m_wrongProxyVer = jcMsg.jcMSG079;

    private   static final int  PROXY_VER = 5;

    protected RoundtableImpl m_RoundtableImpl;

    //---- Constructors
    public Roundtable(Connection connection)
        throws Open4GLException,
               ConnectException,
               SystemErrorException,
               IOException
    {
        /* we must do this here before we attempt to create the appobject */
        if (RunTimeProperties.getDynamicApiVersion() != PROXY_VER)
            throw new Open4GLException(m_wrongProxyVer, null);

        String urlString = connection.getUrl();
        if (urlString == null || urlString.compareTo("") == 0)
            connection.setUrl("Roundtable");

        m_RoundtableImpl = new RoundtableImpl(
                                  "Roundtable",
                                  connection,
                                  RunTimeProperties.tracer);
    }

    public Roundtable(String urlString,
                        String userId,
                        String password,
                        String appServerInfo)
        throws Open4GLException,
               ConnectException,
               SystemErrorException,
               IOException
    {
        Connection connection;

        /* we must do this here before we attempt to create the appobject */
        if (RunTimeProperties.getDynamicApiVersion() != PROXY_VER)
            throw new Open4GLException(m_wrongProxyVer, null);

        connection = new Connection(urlString,
                                    userId,
                                    password,
                                    appServerInfo);

        m_RoundtableImpl = new RoundtableImpl(
                                  "Roundtable",
                                  connection,
                                  RunTimeProperties.tracer);

        /* release the connection since the connection object */
        /* is being destroyed.  the user can't do this        */
        connection.releaseConnection();
    }

    public Roundtable(String userId,
                        String password,
                        String appServerInfo)
        throws Open4GLException,
               ConnectException,
               SystemErrorException,
               IOException
    {
        Connection connection;

        /* we must do this here before we attempt to create the appobject */
        if (RunTimeProperties.getDynamicApiVersion() != PROXY_VER)
            throw new Open4GLException(m_wrongProxyVer, null);

        connection = new Connection("Roundtable",
                                    userId,
                                    password,
                                    appServerInfo);

        m_RoundtableImpl = new RoundtableImpl(
                                  "Roundtable",
                                  connection,
                                  RunTimeProperties.tracer);

        /* release the connection since the connection object */
        /* is being destroyed.  the user can't do this        */
        connection.releaseConnection();
    }

    public Roundtable()
        throws Open4GLException,
               ConnectException,
               SystemErrorException,
               IOException
    {
        Connection connection;

        /* we must do this here before we attempt to create the appobject */
        if (RunTimeProperties.getDynamicApiVersion() != PROXY_VER)
            throw new Open4GLException(m_wrongProxyVer, null);

        connection = new Connection("Roundtable",
                                    null,
                                    null,
                                    null);

        m_RoundtableImpl = new RoundtableImpl(
                                  "Roundtable",
                                  connection,
                                  RunTimeProperties.tracer);

        /* release the connection since the connection object */
        /* is being destroyed.  the user can't do this        */
        connection.releaseConnection();
    }

    public void _release() throws Open4GLException, SystemErrorException
    {
        m_RoundtableImpl._release();
    }

    //---- Get Connection Id
    public Object _getConnectionId() throws Open4GLException
    {
        return (m_RoundtableImpl._getConnectionId());
    }

    //---- Get Request Id
    public Object _getRequestId() throws Open4GLException
    {
        return (m_RoundtableImpl._getRequestId());
    }

    //---- Get SSL Subject Name
    public Object _getSSLSubjectName() throws Open4GLException
    {
        return (m_RoundtableImpl._getSSLSubjectName());
    }

    //---- Is there an open output temp-table?
    public boolean _isStreaming() throws Open4GLException
    {
        return (m_RoundtableImpl._isStreaming());
    }

    //---- Stop any outstanding request from any object that shares this connection.
    public void _cancelAllRequests() throws Open4GLException
    {
        m_RoundtableImpl._cancelAllRequests();
    }

    //---- Return the last Return-Value from a Progress procedure
    public String _getProcReturnString() throws Open4GLException
    {
        return (m_RoundtableImpl._getProcReturnString());
    }

    //---- Create an SDO ResultSet object - There are 3 overloaded variations
    public SDOResultSet _createSDOResultSet(String procName)
        throws Open4GLException, ProSQLException
    {
        return (m_RoundtableImpl._createSDOResultSet(procName, null, null, null));
    }

    public SDOResultSet _createSDOResultSet(String procName,
                                            String whereClause,String sortBy)
        throws Open4GLException, ProSQLException
    {
        return (m_RoundtableImpl._createSDOResultSet(procName, whereClause, sortBy, null));
    }

    public SDOResultSet _createSDOResultSet(String procName,
                                          String whereClause,
                                          String sortBy,
                                          SDOParameters params)
        throws Open4GLException, ProSQLException
    {
        return (m_RoundtableImpl._createSDOResultSet(procName, whereClause, sortBy, params));
    }

    // Create the ProcObject that knows how to talk to SDO's.
    public SDOInterface _createSDOProcObject(String procName)
        throws Open4GLException
    {
        return (m_RoundtableImpl._createSDOProcObject(procName));
    }

	/**
	*	
	*	
	*/
	public Transaction createPO_Transaction()
		throws Open4GLException, RunTime4GLException, SystemErrorException
	{
		return new Transaction(m_RoundtableImpl);
	}

	/**
	*	
	*	
	*/
	public String checkClientVersion(String pcClientVer)
		throws Open4GLException, RunTime4GLException, SystemErrorException
	{
		return m_RoundtableImpl.checkClientVersion( pcClientVer);
	}

	/**
	*	
	*	
	*/
	public String getByteContent(String pcContentId, LongHolder piBlockNum, MemptrHolder pmData)
		throws Open4GLException, RunTime4GLException, SystemErrorException
	{
		return m_RoundtableImpl.getByteContent( pcContentId,  piBlockNum,  pmData);
	}

	/**
	*	
	*	
	*/
	public String getServerVersion(StringHolder pcServerVer)
		throws Open4GLException, RunTime4GLException, SystemErrorException
	{
		return m_RoundtableImpl.getServerVersion( pcServerVer);
	}

	/**
	*	
	*	
	*/
	public String initialize()
		throws Open4GLException, RunTime4GLException, SystemErrorException
	{
		return m_RoundtableImpl.initialize();
	}

	/**
	*	
	*	
	*/
	public String processRequest(StringHolder plcXml)
		throws Open4GLException, RunTime4GLException, SystemErrorException
	{
		return m_RoundtableImpl.processRequest( plcXml);
	}

	/**
	*	
	*	
	*/
	public String setByteContent(String pcContentId, long piBlockNum, Memptr pmData)
		throws Open4GLException, RunTime4GLException, SystemErrorException
	{
		return m_RoundtableImpl.setByteContent( pcContentId,  piBlockNum,  pmData);
	}



}
